package com.simuwang.base.pojo.dto.report;

import cn.hutool.core.date.DateUtil;
import com.simuwang.base.pojo.dos.report.ReportFundInfoDO;
import lombok.Getter;
import lombok.Setter;

import java.math.BigDecimal;

/**
 * @author wangzaijun
 * @date 2024/9/26 16:47
 * @description 报告基金基本信息
 */
@Setter
@Getter
public class ReportFundInfoDTO extends BaseReportDTO<ReportFundInfoDO> {
    private String advisorName;
    private String custodianName;
    private String fundManager;
    private String fundName;
    private String fundStrategyDescription;
    private String inceptionDate;
    private String industryTrend;
    private String investmentObjective;
    private BigDecimal leverage;
    private String leverageNote;
    private String operationType;
    private String registerNumber;
    private String riskReturnDesc;
    private String secondaryBenchmark;
    private String trustName;

    private String dueDate;
    private String isReviewed;

    @Override
    public ReportFundInfoDO toEntity() {
        ReportFundInfoDO entity = new ReportFundInfoDO();
        entity.setFileId(this.getFileId());
        entity.setAdvisorName(this.advisorName);
        entity.setCustodianName(this.custodianName);
        entity.setFundManager(this.fundManager);
        entity.setFundName(this.fundName);
        entity.setFundStrategyDescription(this.fundStrategyDescription);
        entity.setInceptionDate(this.inceptionDate == null ? null : DateUtil.parseDate(this.inceptionDate));
        entity.setIndustryTrend(this.industryTrend);
        entity.setInvestmentObjective(this.investmentObjective);
        entity.setLeverage(this.leverage);
        entity.setLeverageNote(this.leverageNote);
        entity.setOperationType(this.operationType);
        entity.setRegisterNumber(this.registerNumber);
        entity.setRiskReturnDesc(this.riskReturnDesc);
        entity.setSecondaryBenchmark(this.secondaryBenchmark);
        entity.setTrustName(this.trustName);
        entity.setDueDate(this.dueDate == null ? null : DateUtil.parseDate(this.dueDate));
        entity.setIsReviewed(this.isReviewed);
        return entity;
    }

    @Override
    public String toString() {
        return "{" +
                super.toString() +
                ", advisorName='" + advisorName + '\'' +
                ", fundName='" + fundName + '\'' +
                ", inceptionDate='" + inceptionDate + '\'' +
                ", registerNumber='" + registerNumber + '\'' +
                ", trustName='" + trustName + '\'' +
                ", dueDate='" + dueDate + '\'' +
                '}';
    }
}
